<?php

/*
Addon: Boxmessage WPB
*/

class BoxmessageWPB_Addon {

	/*
	 * Contruct
	 */
    public function __construct() {

        add_action('wp_enqueue_scripts', array($this, 'load_scripts'));

        add_shortcode('boxmessagewpb_wpb_addon', array($this, 'shortcode_addon_func'));

        add_action('init', array($this, 'map_vc_addon'));

    }

    function load_scripts() {
		
		wp_enqueue_style( 'animations' );
		wp_enqueue_script( 'appear' );			
		wp_enqueue_script( 'animate' );
		
    }
	
	/*
	 * Addon View
	 */
    public function shortcode_addon_func($atts, $content = null, $tag) {
		static $instance;
		$instance++;
        $date = '';

        extract(shortcode_atts(array(

				"boxmessagge_type" => 'default',
				"boxmessagge_default_type" => 'bme_message-info',
				"boxmessagge_default_style" => 'vc_alert_rounded',				
				"boxmessagge_custom_icon" => 'fas fa-plus', 
				"boxmessagge_custom_size" => '15',
				"boxmessagge_custom_icon_float" => 'left', 
				"boxmessagge_custom_icon_color" => '#000FFF',
				"boxmessagge_custom_background_color" => '#000FFF',  
				"boxmessagge_custom_margin" => '5px', 
				"boxmessagge_custom_padding" => '5px',
				"boxmessagge_custom_background_border_3d_color" => '',
				"boxmessagge_text" => '',
				"boxmessagge_default_rtl" => 'off',
				"boxmessagge_custom_text_size" => '14px',
				'addon_animate'				=> 'off',
				'effect'					=> 'fade-in',
				'delay'						=> '0',
			
        ), $atts));

		wp_enqueue_script( 'appear' );			
		wp_enqueue_script( 'animate' );
		wp_enqueue_style( 'animations' );
		wp_enqueue_style( 'boxmessage-style' );

		$type = 'fontawesome';
		vc_icon_element_fonts_enqueue( $type );

		$return = '';
		
	// DEFAULT
	if($boxmessagge_type == 'default') {
			$return .= '<style type="text/css">
							.boxmessage-'.esc_html($instance).' .boxmessage_text {
								font-size:'.esc_html($boxmessagge_custom_text_size).';
							}
							.boxmessage-'.esc_html($instance).' i {
								font-size:'.esc_html($boxmessagge_custom_size).';
								padding:'.esc_html($boxmessagge_custom_padding).';
							}</style>';		
		if($addon_animate == 'on') {
			$return .= '<div class="boxmessage-'.esc_html($instance).' bme_message bme_content_element '.esc_html($boxmessagge_default_type).' boxmessage-rtl-'.esc_html($boxmessagge_default_rtl).' '.esc_html($boxmessagge_default_style).' animate-in" data-anim-type="'.esc_html($effect).'" data-anim-delay="'.esc_html($delay).'">
							<div class="boxmessage_text"><div class="icon-container"><i class="fa ';
							
							if($boxmessagge_default_type == 'bme_message-info') {	
								$return .= 'fa-info-circle';								
							}
							if($boxmessagge_default_type == 'bme_message-warning') {	
								$return .= 'fa-exclamation-triangle';								
							}
							if($boxmessagge_default_type == 'bme_message-success') {	
								$return .= 'fa-check';								
							}
							if($boxmessagge_default_type == 'bme_message-danger') {	
								$return .= 'fa-times';								
							}							
							
							$return .= '"></i></div><div class="message-text">'.esc_html($boxmessagge_text).'</div><div class="clearfix"></div></div>
						</div>';
		} else {
			$return .= '<div class="boxmessage-'.esc_html($instance).' bme_message bme_content_element '.esc_html($boxmessagge_default_type).' boxmessage-rtl-'.esc_html($boxmessagge_default_rtl).' '.esc_html($boxmessagge_default_style).'">
							<div class="boxmessage_text"><div class="icon-container"><i class="fa ';
							
							if($boxmessagge_default_type == 'bme_message-info') {	
								$return .= 'fa-info-circle';								
							}
							if($boxmessagge_default_type == 'bme_message-warning') {	
								$return .= 'fa-exclamation-triangle';								
							}
							if($boxmessagge_default_type == 'bme_message-success') {	
								$return .= 'fa-check';								
							}
							if($boxmessagge_default_type == 'bme_message-danger') {	
								$return .= 'fa-times';								
							}							
							
							$return .= '"></i></div><div class="message-text">'.esc_html($boxmessagge_text).'</div><div class="clearfix"></div></div>
						</div>';				
		}
		
	}
	
	// CUSTOM
	if($boxmessagge_type == 'custom') {
		if($addon_animate == 'on') {
			$return .= '<style type="text/css">
							.boxmessage-'.esc_html($instance).' .boxmessage_text {
								background:none!important;
								text-shadow:0 0 0;
								color:'.esc_html($boxmessagge_custom_icon_color).';
								font-size:'.esc_html($boxmessagge_custom_text_size).';
							}
							.boxmessage-'.esc_html($instance).' {
								background-color:'.esc_html($boxmessagge_custom_background_color).'!important;							
								border-color:'.esc_html($boxmessagge_custom_background_color).'!important;
																						
							}
							.boxmessage-'.esc_html($instance).' i {
								float:'.esc_html($boxmessagge_custom_icon_float).';
								margin:'.esc_html($boxmessagge_custom_margin).';
								padding:'.esc_html($boxmessagge_custom_padding).';
								color:'.esc_html($boxmessagge_custom_icon_color).';
								font-size:'.esc_html($boxmessagge_custom_size).';
							}';
			if($boxmessagge_default_style == 'vc_alert_3d') {				
					$return .= '.boxmessage-'.esc_html($instance).' {
								box-shadow:0 5px 0 '.esc_html($boxmessagge_custom_background_border_3d_color).';
					}';
			}			
			echo	'</style>';
			
			$return .= '<div class="boxmessage-'.esc_html($instance).' bme_message bme_content_element '.esc_html($boxmessagge_default_style).' animate-in" data-anim-type="'.esc_html($effect).'" data-anim-delay="'.esc_html($delay).'">
								<div class="boxmessage_text">
								
								<i class="'.$boxmessagge_custom_icon.'"></i>
										
								'.esc_html($boxmessagge_text).'</div>
						</div>';
		} else {
			$return .= '<style type="text/css">
							.boxmessage-'.esc_html($instance).' .boxmessage_text {
								background:none!important;
								text-shadow:0 0 0;
								color:'.esc_html($boxmessagge_custom_icon_color).';
								font-size:'.esc_html($boxmessagge_custom_text_size).';
							}
							.boxmessage-'.esc_html($instance).' {
								background-color:'.esc_html($boxmessagge_custom_background_color).'!important;							
								border-color:'.esc_html($boxmessagge_custom_background_color).'!important;														
							}
							.boxmessage-'.esc_html($instance).' i {
								float:'.esc_html($boxmessagge_custom_icon_float).';
								margin:'.esc_html($boxmessagge_custom_margin).';
								padding:'.esc_html($boxmessagge_custom_padding).';
								color:'.esc_html($boxmessagge_custom_icon_color).';
								font-size:'.esc_html($boxmessagge_custom_size).';
							}';
			if($boxmessagge_default_style == 'vc_alert_3d') {				
					$return .= '.boxmessage-'.esc_html($instance).' {
								box-shadow:0 5px 0 '.esc_html($boxmessagge_custom_background_border_3d_color).';
					}';
			}							
			$return .= '</style>';

			$return .= '<div class="boxmessage-'.esc_html($instance).' bme_message bme_content_element '.esc_html($boxmessagge_default_style).'">
						<div class="boxmessage_text">
								
					    <i class="'.$boxmessagge_custom_icon.'"></i>
								
						'.esc_html($boxmessagge_text).'</div>
			</div>';		
		}
	}
			return $return;
	} 



	
	/*
	 * Addon Backend
	 */	
    function map_vc_addon() {
        if (function_exists("vc_map")) {

            vc_map(array(
                "name" => esc_html__("Box Message", "boxmessagewpb"),
                "base" => "boxmessagewpb_wpb_addon",
                "content_element" => true,
                "show_settings_on_create" => true,
                "category" => esc_html__("Box Message", "boxmessagewpb"),
                'description' => esc_html__('add your Boxmessage', 'boxmessagewpb'),
                "icon" => BOXMESSAGEWPB_URL . '/assets/img/vc-boxmessage.png',
                "params" => array(			
					   array(
						  "type" => "dropdown",
						  "class" => "",
						  "heading" => __("Type Box Message", 'boxmessagewpb'),
						  "param_name" => "boxmessagge_type",
						  "value" => array(
											__('Default','boxmessagewpb')  	=> 'default',
											__('Custom','boxmessagewpb') 	=> 'custom',
						   )
						),			
					
					
					
						// DEFAULT		
					
						array(
						  "type" => "dropdown",
						  "class" => "",
						  "heading" => __("Type Default Message", 'boxmessagewpb'),
						  "param_name" => "boxmessagge_default_type",
						  "value" => array(
											__('Info','boxmessagewpb')  	=> 'bme_message-info',
											__('Alert','boxmessagewpb') 	=> 'bme_message-warning',
											__('Success','boxmessagewpb') 	=> 'bme_message-success',
											__('Error','boxmessagewpb') 	=> 'bme_message-danger'
						   ),
						  'dependency' => array(
								'element' => 'boxmessagge_type',
								'value' => array( 'default' )
						  ),				   
						),			

						array(
						  "type" => "dropdown",
						  "class" => "",
						  "heading" => __("RTL", 'boxmessagewpb'),
						  "param_name" => "boxmessagge_default_rtl",
						  "value" => array(
											__('Off','boxmessagewpb')  	=> 'off',
											__('On','boxmessagewpb') 	=> 'on'
						   ),
						  'dependency' => array(
								'element' => 'boxmessagge_type',
								'value' => array( 'default' )
						  ),				   
						),						
					
						// BOTH
						
						array(
						  "type" => "dropdown",
						  "class" => "",
						  "heading" => __("Style", 'boxmessagewpb'),
						  "param_name" => "boxmessagge_default_style",
						  "value" => array(
											__('Rounded','boxmessagewpb')  	=> 'vc_alert_rounded',
											__('Square','boxmessagewpb') 	=> 'vc_alert_square',
											__('Round','boxmessagewpb') 	=> 'vc_alert_round',
											__('Outlined','boxmessagewpb') 	=> 'vc_alert_outlined',
											__('3D','boxmessagewpb') 	=> 'vc_alert_3d',
											__('Square Outlined','boxmessagewpb') 	=> 'vc_alert_square_outlined',									
						   ),				   
						),				

					
					  // CUSTOM
								 
					array(
						"type" => "iconpicker",
						"heading" => esc_html__( "Icon", 'boxmessagewpb' ),
						"param_name" => "boxmessagge_custom_icon",
						"settings" => array(
							"emptyIcon" 	=> false,
							"type" 			=> "fontawesome",
							"iconsPerPage" 	=> 200,
						),						
						"description" => esc_html__( "Select icon from library.", 'boxmessagewpb' ),
						  'dependency' => array(
								'element' => 'boxmessagge_type',
								'value' => array( 'custom' )
						  ),						
					),									  
						array(
						  "type" => "dropdown",
						  "class" => "",
						  "heading" => __("Icon Float", 'boxmessagewpb'),
						  "param_name" => "boxmessagge_custom_icon_float",
						  "value" => array(
											__('Left','boxmessagewpb')  	=> 'left',
											__('Right','boxmessagewpb') 	=> 'right',
											__('None','boxmessagewpb') 	=> 'none'
						   ),
						  'dependency' => array(
								'element' => 'boxmessagge_type',
								'value' => array( 'custom' )
						  ),				   
						),              
		 

				
						
						// BOTH
						array(
						  "type" => "textarea",
						  "class" => "",
						  "heading" => __("Text Message",'boxmessagewpb'),
						  "param_name" => "boxmessagge_text",
						  "admin_label" => true					  
						),				
						
						
						// STYLE
					  array(
						  "type" => "textfield",
						  "class" => "",
						  "heading" => __("Text Size (px)",'boxmessagewpb'),
						  "param_name" => "boxmessagge_custom_text_size",
						  "description" => "ex 14px",
						  "group" => "Style"				  				  
					  ),	
					  
					  array(
						  "type" => "textfield",
						  "class" => "",
						  "heading" => __("Icon Size (px)",'boxmessagewpb'),
						  "param_name" => "boxmessagge_custom_size",
						  "description" => "ex 15px",
						  "group" => "Style"				  				  
					  ),				
					  array(
						  "type" => "colorpicker",
						  "class" => "",
						  "heading" => __("Icon Color", 'boxmessagewpb'),
						  "param_name" => "boxmessagge_custom_icon_color",
						  "value" => '#FC615D',
						  'dependency' => array(
								'element' => 'boxmessagge_type',
								'value' => array( 'custom' )
						  ),
						  "group" => "Style"				  
					  ),					  		  
					  array(
						  "type" => "textfield",
						  "class" => "",
						  "heading" => __("Icon Margin",'boxmessagewpb'),
						  "param_name" => "boxmessagge_custom_margin",
						  "description" => "ex 2px or 2px 2px 2px 2px",		
						  'dependency' => array(
								'element' => 'boxmessagge_type',
								'value' => array( 'custom' )
						  ),
						  "group" => "Style"				  		  
					  ),
					  array(
						  "type" => "textfield",
						  "class" => "",
						  "heading" => __("Icon Padding",'boxmessagewpb'),
						  "param_name" => "boxmessagge_custom_padding",
						  "description" => "ex 2px or 2px 2px 2px 2px",
						  'dependency' => array(
								'element' => 'boxmessagge_type',
								'value' => array( 'custom' )
						  ),
						  "group" => "Style"				  				  
					  ),				
					 array(
						  "type" => "colorpicker",
						  "class" => "",
						  "heading" => __("Background Color", 'boxmessagewpb'),
						  "param_name" => "boxmessagge_custom_background_color",
						  "value" => '#FC615D',
						  'dependency' => array(
								'element' => 'boxmessagge_type',
								'value' => array( 'custom' )
						  ),
						  "group" => "Style"				  
					  ), 				
						
					 array(
						  "type" => "colorpicker",
						  "class" => "",
						  "heading" => __("Border Color only For 3d Box", 'boxmessagewpb'),
						  "param_name" => "boxmessagge_custom_background_border_3d_color",
						  "value" => '#FC615D',
						  'dependency' => array(
								'element' => 'boxmessagge_type',
								'value' => array( 'custom' )
						  ),
						  "group" => "Style"				  
					  ),

					
					// ANIMATION								  							  		  
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Animate", 'boxmessagewpb'),
						"param_name" => "addon_animate",
						"value" => array(
										esc_html__('Off','boxmessagewpb') 	=> 'off',
										esc_html__('On','boxmessagewpb') 	=> 'on'
										
						),
						"dependency" => array(
							"element" => "pagination",
							"value" => array( "no", "yes" )
						),						
						"group" => "Animation"
					),			  
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Animate Effects", 'boxmessagewpb'),
						"param_name" => "effect",
						"value" => boxmessagewpb_animation_effect(),
						"dependency" => array(
							"element" => "addon_animate",
							"value" => array( "on" )
						),
						"group" => "Animation"				   
					),				  
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Animate Delay (ms)",'boxmessagewpb'),
						"param_name" => "delay",
						"description" => "ex 1000",					  
						"dependency" => array(
							"element" => "addon_animate",
							"value" => array( "on" )
						),
						"value" => "0",
						"group" => "Animation"					  
					),
                ),
            ));


        }
    }

} // End Class

if (class_exists('WPBakeryShortCode')) {
    class WPBakeryShortCode_BoxmessageWPB_Addon extends WPBakeryShortCode {
    }
}

// Initialize Element Class
if (class_exists('BoxmessageWPB_Addon')) {
    new BoxmessageWPB_Addon();
}