<?php

if (!class_exists('Boxmessage_WPB_Main')) :

    /**
     * Main Boxmessage_WPB_Main Class
     *
     */
	class Boxmessage_WPB_Main {

		private static $instance;

        public static function instance() {
            if (!isset(self::$instance) && !(self::$instance instanceof Boxmessage_WPB_Main)) {

                self::$instance = new Boxmessage_WPB_Main;
				
				add_action('plugins_loaded', array(self::$instance, 'load_plugin_textdomain'));
				add_action('plugins_loaded', array(self::$instance, 'include_addons'));
				add_action('plugins_loaded', array(self::$instance, 'includes_files'));

				add_action('wp_enqueue_scripts', array(self::$instance, 'load_general_scripts'));            


            }
            return self::$instance;
        }

        /**
         * Load Plugin Text Domain
         */
        public function load_plugin_textdomain() {
			$path = dirname(plugin_basename( __FILE__ )) . '/languages/';
			$loaded = load_plugin_textdomain( 'boxmessagewpb', false, $path);
        }


        /**
         * Include required files
         *
         */
        public function includes_files() {

            /* Load VC Field Types */
            include_once( plugin_dir_path( __FILE__ ) . 'includes/functions.php' );
            include_once( plugin_dir_path( __FILE__ ) . 'includes/helper.php' );


        }

        /**
         * Include VC Addons
         *
         */
        public function include_addons() {
			
			include_once( plugin_dir_path( __FILE__ ) . 'addons/boxmessage/class-boxmessagewpb.php' );

        }

        /**
         * Load general scripts
         */
        public function load_general_scripts() {

					// Load WP jQuery if not included
					wp_enqueue_script('jquery');

					// Main
					wp_register_style( 'boxmessage-style', plugins_url( '/assets/css/style.css', __FILE__ ) );
					wp_enqueue_style( 'boxmessage-style' );

					// ANIMATE
					wp_register_style( 'animations',  plugins_url( 'assets/css/animations.min.css', __FILE__ ) );
					wp_register_script( 'appear',  plugins_url( 'assets/js/vendor/appear.min.js' , __FILE__ ), [ 'jquery' ], false, true );
					wp_register_script( 'animate',  plugins_url( 'assets/js/vendor/animations.min.js' , __FILE__ ), [ 'jquery' ], false, true );

        }

	}


endif; // End if class_exists check

function BoxmessageWPB() {
    return Boxmessage_WPB_Main::instance();
}

// Get BoxmessageWPB Running
BoxmessageWPB();
